<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- This file has been generated by tj3man v3.1.0 -->
<html lang="en" xml:lang="en" xmlns="http://www.w3.org/1999/xhtml">
 <head>
  <title>Installation</title>
  <meta content="text/html; charset=utf-8" http-equiv="Content-Type"/>
 </head>
 <link href="css/tjmanual.css" rel="stylesheet" type="text/css"></link>
 <body>
  <div align="center">
   <h3 align="center">The TaskJuggler User Manual</h3>
   <em align="center">Project Management beyond Gantt Chart Drawing</em>
  </div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="Reporting_Bugs.html">Reporting_Bugs</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="How_To_Contribute.html">How_To_Contribute</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div style="width:90%; margin-left:5%; margin-right:5%"><div class="manual">
    <h1 class="manual" id="Installation">2 Installation</h1>
    <p class="manual">TaskJuggler 3.x is written in <a href="http://www.ruby-lang.org" target="_top">Ruby</a>. It should run on any platform that Ruby is available on. It uses the standard Ruby mechanism for distribution, a package format called <a href="http://docs.rubygems.org" target="_top">RubyGems</a>.</p>
    <h2 class="manual" id="Requirements">2.1 Requirements</h2>
    <p class="manual">Ruby applications are platform independent. There is no need to compile anything. But TaskJuggler has a very small set of dependencies that you have to take care of first. Please make sure you have the minimum required version installed.</p>
    <h3 class="manual" id="Supported_Operating_Systems">2.1.1 Supported Operating Systems</h3>
    <ul><li>
      <b>Linux</b>: Linux is the primary development platform for TaskJuggler. Releases are tested on recent openSUSE versions.</li></ul>
    <ul><li>
      <b>Other Unix OSes</b>: Should work as well, but releases are not tested on these OSes.</li></ul>
    <ul><li>
      <b>Windows</b>: Windows7 and some older version of Windows should work. There is no maintainer for this platform, so all releases are not tested on this platform.</li></ul>
    <ul><li>
      <b>MacOSX</b>: Will probably work as well. Releases are not tested on this OS. Older MacOS versions will likely not work.</li></ul>
    <p class="manual">If you are interested in becoming the maintainer for any of the currently unmaintained (and untested) OSes, please contact us via the developer mailing list.</p>
    <h3 class="manual" id="Other_required_Software">2.1.2 Other required Software</h3>
    <ul><li>
      <b>Ruby:</b> TaskJuggler 3.x is written in Ruby. You need a Ruby runtime environment to run it. This can be downloaded from <a href="http://www.ruby-lang.org/en/downloads/" target="_top">here</a>. Most Linux distributions usually have Ruby already included. So does MacOS X Leopard. For Windows, there is a one-click installer available. The recommended Ruby version to make full use of TaskJuggler is 1.9.2. Ruby 1.9.1 contains some bugs that prevent the multi-core support to work. For users that are not interested in multi-core support, the web server, the time sheet infrastructure and daemon Ruby 1.8.7 is still ok to use. On Windows you need at least Ruby 1.9.2.</li></ul>
    <p class="manual">See below for instructions on how to use the latest and greates Ruby version in parallel with your distribution Ruby.</p>
    <ul><li>
      <b>RubyGems:</b> If it did not come with your OS or the Ruby installation, see <a href="http://docs.rubygems.org" target="_top">here</a> how to get and install it. RubyGems is a cross-platform package manager. It will download and install all other required software packages automatically when you install TaskJuggler. These packages are called Ruby gems.</li></ul>
    <p class="manual">Other versions of Ruby (Rubinius, JRuby, etc.) may work but have not been tested.</p>
    <h2 class="manual" id="Installation_Steps_for_Users">2.2 Installation Steps for Users</h2>
    <h3 class="manual" id="The_easy_way">2.2.1 The easy way</h3>
    <h4 class="manual" id="System_Wide_Installation">2.2.1.1 System Wide Installation</h4>
    <p class="manual">TaskJuggler is a commandline tool. It does not (yet) have a graphical user interface. To use it, you need to know how to open a command or terminal window. In this manual, we refer to it as your shell. The following paragraphs describe the commands you need to type into your <a href="http://en.wikipedia.org/wiki/Shell_(computing)" target="_top">shell</a>.</p>
    <p class="manual">On systems that already have Ruby and the gem package manager installed you can simply type the following command as root or admin user into your shell or command window:</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> gem install taskjuggler
</pre></div>
    <p class="manual">This will download and install the latest version from the <a href="http://rubygems.org/gems/taskjuggler" target="_top">RubyGems.org</a> site.</p>
    <h4 class="manual" id="Installation_into_a_local_Directory">2.2.1.2 Installation into a local Directory</h4>
    <p class="manual">If you don't want to install TaskJuggler for all users on the system, you can also install it into your home or data directory. This does not require root or admin permissions.</p>
    <p class="manual">The following steps are describe the installation on a Linux system with the bash shell. You may have to use slightly different commands on a different operating system.</p>
    <p class="manual">Create a new directory <code class="manual">taskjuggler</code> in your $HOME directory for the installation to go into.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> mkdir taskjuggler
</pre></div>
    <p class="manual">Install the gem and all dependencies.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> gem install --install-dir taskjuggler taskjuggler-X.X.X.gem
</pre></div>
    <p class="manual">If you must use a proxy to access the Internet, you need to set a shell environment variable so <code class="manual">gem</code> can find and use it. The setting below needs to be adapted to your local environment. Check with your admin or IT department if needed.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> export HTTP_PROXY=http://%USER%:%PASSWORD%@%SERVER%:%PORT%
</pre></div>
    <p class="manual">Configure your <code class="manual">PATH</code> variable to find the taskjuggler programs.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> export PATH="${PATH}:${HOME}/taskjuggler/bin"
</pre></div>
    <p class="manual">Configure gem to find the installed files.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> export GEM_HOME=${HOME}/taskjuggler
</pre></div>
    <p class="manual">The last two settings should also be added to your .profile file to make them permanent.</p>
    <p class="manual">That's it. You now should be run TaskJuggler.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> tj3 --version
</pre></div>
    <h3 class="manual" id="The_manual_way">2.2.2 The manual way</h3>
    <p class="manual">If the easy way doesn't work for you, you need to download and install the packages manually. Download TaskJuggler gem file from the <a href="http://rubygems.org/gems/taskjuggler" target="_top">RubyGems.org</a> site.</p>
    <p class="manual">A gem package is an operating system and architecture independent archive file for Ruby programs. You can install it on any system that has Ruby and RubyGems installed. Normally, you should be logged-in as root or administrator to run the following installation command. Replace the X.X.X with the actual version that you have downloaded.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">gem install pkg/taskjuggler-X.X.X.gem 
</pre></div>
    <p class="manual">It will install all components of the Gem in the appropriate place.</p>
    <p class="manual">On user friendly Linux distributions, the start scripts will be installed in a standard directory like <code class="manual">/usr/bin</code>. On Debian based distributions, the start scripts end up in a place like <code class="manual">/var/lib/gems/1.8/bin/</code> that is not listed in the <code class="manual">PATH</code> variable. You either have to create a symbolic link for each start script or add the directory to your PATH variable. If you use the standard <a href="http://en.wikipedia.org/wiki/Bash" target="_top">bash shell</a>, put the following line in your <code class="manual">${HOME}/.profile</code> file.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">PATH=${PATH}:/var/lib/gems/1.8/bin/
</pre></div>
    <p class="manual">Windows and MacOS platforms may require similar steps.</p>
    <h2 class="manual" id="Update_from_older_TaskJuggler_3x_versions">2.3 Update from older TaskJuggler 3.x versions</h2>
    <p class="manual">Updates work just like the installation.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">gem update taskjuggler
</pre></div>
    <p class="manual">For downloaded or self-built packages use the following command:</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">gem update pkg/taskjuggler-X.X.X.gem
</pre></div>
    <h2 class="manual" id="Installing_TaskJuggler_from_the_Git_Repository">2.4 Installing TaskJuggler from the Git Repository</h2>
    <p class="manual">The following description is for developers and users that want to learn more about TaskJuggler or want to make improvements. TaskJuggler is <a href="http://en.wikipedia.org/wiki/Open_source" target="_top">Open Source</a> software and you are encouraged to read and modify the source code.</p>
    <p class="manual">Before you download the source code, make sure you have all the necessary dependencies installed. You should have Ruby 1.9.2 or later and you need to have the following gems installed</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">gem install rake mail rspec term-ansicolor rcov
</pre></div>
    <p class="manual">rcov is optional, but you must have the other gems and their dependencies installed.</p>
    <p class="manual">To get the source code, the recommended way it to check out the latest code from the developer repository. To do this, you need to have <a href="http://www.kernel.org/pub/software/scm/git/docs/" target="_top">git</a> installed.</p>
    <p class="manual">Then checkout the source code with the following command</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git clone http://www.taskjuggler.org/git-repos/taskjuggler3.git
</pre></div>
    <p class="manual">Make sure, you have removed all previously installed instances of TaskJuggler from your system before doing so. It is a common mistake to have an old version of the TaskJuggler installed and then use parts of the old and new version together.</p>
    <p class="manual">If your Ruby installation does not come with the <a href="http://rake.rubyforge.org" target="_top">Rake</a> build tool, you need to install it now.</p>
    <p class="manual">If you are interested in a code coverage analysis, you need to also install the <a href="http://eigenclass.org/hiki.rb?rcov" target="_top">rcov</a> code coverage analysis tool. This tool is not needed for most developers. You can safely ignore the warning during rake builds if you don't have it installed.</p>
    <p class="manual">The following command will create a gem package from the source code.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">cd taskjuggler3; rake gem
</pre></div>
    <p class="manual">If you plan to modify the TaskJuggler files, creating and installing the gem file for every test run is not very comfortable. To run tj3 from source put the following code in your <code class="manual">.profile</code> file. This is for users of the bash shell. Adapt it accordingly if you use another shell.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"># Make sure the shell finds the TaskJuggler programs
export PATH=${PATH}:${TASKJUGGLER_DIR}/bin
</pre></div>
    <h2 class="manual" id="Quickly_switching_between_various_TaskJuggler_3x_versions">2.5 Quickly switching between various TaskJuggler 3.x versions</h2>
    <p class="manual">One of the benefits of using TaskJuggler from the Git repository is the ability to get the latest bug fixes. If a bug was reported, it is usually fixed fairly quickly, but it can take several weeks before the next official release happens. The following commands must all be executed from within the checked-out Git directory.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git pull
</pre></div>
    <p class="manual">gets you the latest changes. We usually try to keep the head branch stable. Using it should not be much more risky than using a regular release. Nevertheless, problems can occur and a fixed version might take a few days.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git checkout -f XXXXXXXX
</pre></div>
    <p class="manual">will switch your current working copy to the version with commit ID XXXXXXXX. Alternatively, you can also use tag names.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git checkout -f release-0.0.10
</pre></div>
    <p class="manual">This will switch to the released version 0.0.10.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">git tag
</pre></div>
    <p class="manual">provides you with a list of all tags.</p>
    <p class="manual">TaskJuggler 3.x is written in Ruby. There is no make or build process needed. Every code change is effective immediately. The tutorial, the manual and some other parts do require a build step.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">rake release
</pre></div>
    <p class="manual">will do it all and even create installable gem files again.</p>
    <h2 class="manual" id="Installing_a_newer_Ruby_version">2.6 Installing a newer Ruby version</h2>
    <p class="manual">New Ruby versions are released usually about once or twice a year. Unfortunately, it takes some time before Linux distributions pick up the new release. Depending on your distribution, this can take anything from a few weeks to several years. Many distributions still have not yet made the switch to Ruby 1.9. The core part of TaskJuggler can be used with Ruby 1.8.9, but it is at least 3 times slower. Therefor it is recommended, that you install the latest stable release of Ruby to use TaskJuggler. This can easily and safely being done in parallel to your distribution Ruby. Both versions can be used in parallel without interfering each other.</p>
    <p class="manual">This section only covers Linux. For other operating system, please search the web for instructions. If you want to contribute the description for another OS, please see <a href="How_To_Contribute.html">How_To_Contribute</a>.</p>
    <p class="manual">First, you need to download the source code of the latest stable release from <a href="http://www.ruby-lang.org/en/downloads/" target="_top">www.ruby-lang.org</a>.</p>
    <p class="manual">The source code is distributed as zipped tarfile. You can extract it like this. Change the file name to the actual version you have downloaded.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> tar -Zxvf ruby-X.X.X-*.tar.gz
</pre></div>
    <p class="manual">This will create a directory with the same name as the archive, but without the <code class="manual">.tar.gz</code> extension. Now change into this directory and configure the source code for your specific OS and compile it. For this to work, you need to have the GNU C compiler and related utilities installed. We configure Ruby to append <code class="manual">19</code> to all executable names. This way, you can easily choose if you want to run the old or the new Ruby. <code class="manual">ruby</code> runs your distribution Ruby, <code class="manual">ruby19</code> runs your new ruby.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> cd ruby-X.X.X-*
 ./configure --program-suffix=19
 make
</pre></div>
    <p class="manual">If all goes well, you can install it now. This requires root permission, so you need to enter the root password. All executables will be installed into <code class="manual">/usr/local/bin</code>.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> sudo make install
</pre></div>
    <p class="manual">As a final step, you need to install the <code class="manual">mail</code> and <code class="manual">term-ansicolor</code> gems.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> sudo gem19 install mail term-ansicolor
</pre></div>
    <p class="manual">If you don't want to use TaskJuggler from the git repository, you can install the TaskJuggler gem as well.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> sudo gem19 install taskjuggler
</pre></div>
    <p class="manual">The TaskJuggler front-end scripts always use the <code class="manual">ruby</code> interpreter that's the first in the PATH. You need to set a link in your local <code class="manual">bin</code> directory to point to your <code class="manual">ruby19</code> executable as <code class="manual">ruby</code>. Make sure your <code class="manual">${HOME}/bin</code> directory is the first directory in the <code class="manual">PATH</code>.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> ln -s /usr/local/bin/ruby19 ${HOME}/bin/ruby
</pre></div>
    <p class="manual">That's it. You now have the latest Ruby installed and are ready to use TaskJuggler.</p>
    <h2 class="manual" id="Installing_the_Vim_Support">2.7 Installing the Vim Support</h2>
    <p class="manual">TaskJuggler can be used with any text editor that supports UTF-8 text file editing. If you don't have a preference yet, we recommend to try the <a href="http://www.vim.org" target="_top">Vim</a> text editor. It's a very powerful editor and it has been customized for better integration with TaskJuggler. This section describes, how to activate and use the Vim integration. Vim is provided by pretty much any Linux distribution and also works well on MacOX and Windows. See the web page for how to install it if you don't have it yet.</p>
    <p class="manual">This section describes the integration on Linux. Please see the <a href="How_To_Contribute.html">How_To_Contribute</a> section if you want to contribute the description for another OS.</p>
    <p class="manual">If you have never customized Vim, you need to create a few directories first.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> cd ${HOME}
 mkdir .vim
 mkdir .vim/syntax
</pre></div>
    <p class="manual">Then copy the syntax file <code class="manual">tjp.vim</code> into the vim syntax directory. The following command works if you have installed TaskJuggler as a gem with the system provided Ruby. For other cases, you may have to modify it accordingly.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1"> cp `gem contents taskjuggler | fgrep tjp.vim` .vim/syntax
</pre></div>
    <p class="manual">Now we have to make sure, Vim detects the file. Edit the <code class="manual">.vim/filetype.vim</code> file to contain the following section.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">augroup filetypedetect
au BufNewFile,BufRead *.tjp,*.tji               setf tjp
augroup END
</pre></div>
    <p class="manual">And edit the <code class="manual">.vim/syntax.vim</code> file to contain the following line.</p>
    <div class="manual" codesection="1"><pre class="manual" codesection="1">au! Syntax tjp          so ~/.vim/syntax/tjp.vim
</pre></div>
    <p class="manual">When you now open a <code class="manual">.tjp</code> or <code class="manual">.tji</code> file in Vim, you should have the following features available:</p>
    <ul>
     <li>Syntax highlighting. TJP keywords should be colored in different colors.</li>
     <li>Syntax folding. The optional parts of properties within the curly braces can be collapsed. For this to work, the opening brace needs to be on the same line as the property keyword. The closing brace must be the first non-blank character of the last line of the block. See the <code class="manual">:help fold</code> Vim help command for details how to open and close folds.</li>
     <li>Tag navigation. If you include a <a href="tagfile" target="_top">tagfile</a> report in your project, Vim will know all property IDs and can jump to them. If you have a task with the ID <code class="manual">foo.bar</code>, the command <code class="manual">:ta foo.bar</code> will put the cursor right where task <code class="manual">foo.bar</code> was declared.</li>
     <li>ID completion. If you include a <a href="tagfile" target="_top">tagfile</a> report in your project, Vim can tell you the full hierarchical ID of a property. Just move the cursor to the first line of the property definition and press <code class="manual">Ctrl-]</code>.</li>
     <li>Run tj3 from within vim. Just type <code class="manual">:make your_project.tjp</code> to start the scheduling process. In case of errors or warnings, you will be able to navigate the errors with <code class="manual">:cn</code> and <code class="manual">:cp</code>.</li>
     <li>Move the cursor over any TaskJuggler syntax keyword and press <code class="manual">shift-k</code> to get the manual page for this keyword.</li>
    </ul>
   </div></div>
  <br/>
  <hr/>
  <table style="width:90%; margin-left:5%; margin-right:5%"><tr>
    <td style="text-align:left; width:35%;">&lt;&lt; <a href="Reporting_Bugs.html">Reporting_Bugs</a> &lt;&lt;</td>
    <td style="text-align:center; width:30%;"><a href="toc.html">Table Of Contents</a></td>
    <td style="text-align:right; width:35%;">&gt;&gt; <a href="How_To_Contribute.html">How_To_Contribute</a> &gt;&gt;</td>
   </tr></table>
  <hr/>
  <br/>
  <div align="center" style="font-size:10px;">Copyright (c) 2006, 2007, 2008, 2009, 2010, 2011, 2012 by Chris Schlaeger &lt;chris@linux.com&gt;.<a href="http://www.taskjuggler.org">TaskJuggler</a> is a trademark of Chris Schlaeger.</div>
 </body>
</html>
